/*
 * 쐬: 2005/01/21
 */
package jp.sourceforge.cafebabe.impl;

import jp.sourceforge.cafebabe.framework.CommandException;
import jp.sourceforge.cafebabe.framework.CommandFatalException;
import jp.sourceforge.cafebabe.framework.CommandSet;
import jp.sourceforge.cafebabe.system.SystemManager;

/**
 * @author jin_k
 */
public class CommandSetImpl extends CommandSet {
	/** !!! private !!! */
	private CommandSetImpl() {
		setName(null);
	}

	/**
	 * RXgN^B
	 * @param name R}hZbg
	 */
	public CommandSetImpl(String name) {
		setName(name);
	}

	/*
	 *  ( Javadoc)
	 * @see jp.sourceforge.cafebabe.framework.CommandSet#callexecute(jp.sourceforge.cafebabe.system.SystemManager, java.lang.String[])
	 */
	public String call(SystemManager manager, String[] args)
			throws CommandFatalException, CommandException {
		CommandSet global = manager.getGlobal();
		String ret = null;
		if (containsCommand(args[0])) {
			ret = getCommand(args[0]).execute(manager, args);
		} else if (null != global && global.containsCommand(args[0])) {
			ret = global.getCommand(args[0]).execute(manager, args);
		} else if (matchAster(args[0]) && containsCommand(ASTERISK)) {
			ret = getCommand(ASTERISK).execute(manager, args);
		} else if (null != global && matchAster(args[0])
				&& global.containsCommand(ASTERISK)) {
			ret = global.getCommand(ASTERISK).execute(manager, args);
		} else {
			ret = COMMAND_NOT_FOUND;
		}
		return ret;
	}
}